import fs from 'node:fs'
import readline from 'node:readline'

const rl = readline.createInterface({
  input: fs.createReadStream('input'),
  output: process.stdout,
  terminal: false
})

let completeValue = 0
let badgesValue = 0
let group = []

rl.on('line', line => {
  let inventory = [
    line.substring(0, line.length/2),
    line.substring(line.length/2)
  ]
  let dublicate = ""
  inventory0Loop:
    for (let item0 of inventory[0]) {
      for (let item1 of inventory[1]) {
        if (item0 === item1) {
          dublicate = item0
          break inventory0Loop
        }
      } 
  }
  completeValue += getPriority(dublicate)

  group.push(line)

  if (group.length > 2) {
    group0Loop:
      for (let item0 of group[0]) {
        for (let item1 of group[1]) {
          for (let item2 of group[2]) {
            if (item0 === item1 && item1 === item2) {
              badgesValue += getPriority(item0)
              break group0Loop
            }  
          }
        }
      }
    group = []
  }
})

rl.on('close', () => {
  console.log('Part 1: The complete Value is: ' + completeValue)
  console.log('Part 2: The badges Value is: ' + badgesValue)
})

function getPriority(item) {
  return item === item.toUpperCase() ? item.charCodeAt() - 38 : item.charCodeAt() - 96
}
