def getMarker(text: str, start: int) -> int:
    marker = 0
    for index in range(start, len(text)):
        dublicate = False
        seen = set()
        for x in text[index-start:index]:
            if x in seen:
                dublicate = True
            else:
                seen.add(x)
        if not dublicate:
            marker = index
            break
    return marker

input = open('./input.txt', 'r')
inputText = input.read()
input.close()
start_of_packet_marker = getMarker(inputText, 4)
print('The packet marker is at position: ' + str(start_of_packet_marker))
start_of_message_marker = getMarker(inputText, 14)
print('The message marker is at position: ' + str(start_of_message_marker))